#include "location.h"

/*#DOC  Title:																*/
/*#DOC    change_weighting													*/
/*#DOC  Desc:																*/
/*#DOC    Changes 'weighting_type' field in solution structure if required.	*/
/*#DOC  Input Arguments:													*/
/*#DOC    sp  - pointer to structure containing current solution.			*/
/*#DOC  Return:																*/
/*#DOC    0/1 for success/failure.											*/

/* Comes here after convergence has been reached with current weighting.	*/
/* If on first weighting type and a second weighting type is given then		*/
/* change weighting to the new type.										*/
/* Also reset the converged flag so that iterating will continue.			*/

int change_weighting (struct sol_rec *sp)
{
	extern char weighting1[];		/* From config file */
	extern char weighting2[];		/* From config file */

	if (strcmp(sp->weighting_type,weighting1)==0){
		if (strcmp(weighting2,"")!=0){
			
			strcpy(sp->weighting_type,weighting2);
			sp->converged = 0;
		}
	}
	return 0;
}
