
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn; 
  unsigned short tvnvsnl; 
  unsigned char *tvnnm;
  unsigned short tvnnml; 
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn; 
  unsigned short adtmode; 
  unsigned short adtnum;  
  sqltvn adttvn[1];       
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,1,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
  unsigned int tdsvsn; 
  unsigned short tdsnum; 
  unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[11];
};
static struct sqlcxp sqlfpn =
{
    10,
    "get_hyp.pc"
};


static unsigned long sqlctx = 75627;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
            void  **sqphsv;
   unsigned int   *sqphsl;
            int   *sqphss;
            void  **sqpind;
            int   *sqpins;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
            void  *sqhstv[20];
   unsigned int   sqhstl[20];
            int   sqhsts[20];
            void  *sqindv[20];
            int   sqinds[20];
   unsigned int   sqharm[20];
   unsigned int   *sqharc[20];
   unsigned short  sqadto[20];
   unsigned short  sqtdso[20];
} sqlstm = {10,20};

/* SQLLIB Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern void sqliem(/*_ char *, int * _*/);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* CUD (Compilation Unit Data) Array */
static short sqlcud0[] =
{10,4130,0,0,0,
5,0,0,1,454,0,4,68,0,0,20,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,2,4,
0,0,2,4,0,0,2,97,0,0,2,97,0,0,2,97,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,4,0,0,
2,4,0,0,2,4,0,0,2,9,0,0,2,9,0,0,1,3,0,0,
100,0,0,2,261,0,4,121,0,0,8,1,0,1,0,2,3,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,
4,0,0,2,4,0,0,1,3,0,0,
};



#include "location.h"

/*#DOC  Title:																*/
/*#DOC    get_hyp															*/
/*#DOC  Desc:																*/
/*#DOC    Fills a hypocentre structure for each hypocentre in this event.	*/
/*#DOC  Input Arguments:													*/
/*#DOC    ep  - pointer to structure containing an event.					*/
/*#DOC    h[] - array of structures containing hypocentres.					*/
/*#DOC  Return:																*/
/*#DOC    0/1 for success/failure.											*/
/*#DOC  Uses:																*/
/*#DOC	  sql_error() from oracle_funcs.									*/
/*#DOC	  This code must be precompiled using the ORACLE proc.				*/

/* In passing, makes a record of the hypid of any ISC hypocentre for this	*/
/* event.  This will be used by put_hyp to avoid having more than one such.	*/


/* EXEC SQL INCLUDE SQLCA;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986, 1998 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    lvbcheng   10/28/98 -  Undo long to int
    lvbcheng   08/03/98 -  Change sqlca long attrs to ints
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


int get_hyp(struct event_rec *ep, struct hyp_rec h[])
{
	int numhyps;
	int i,j;

	/* Local arrays to store selected data. */
	int hypid[MAXHYP];
	int err_hypid[MAXHYP];
	int day[MAXHYP];
	int sec[MAXHYP];
	int msec[MAXHYP];
	double lat[MAXHYP];
	double lon[MAXHYP];
	double depth[MAXHYP];
	char depfix[MAXHYP][1];
	char epifix[MAXHYP][1];
	char timfix[MAXHYP][1];
	int nsta[MAXHYP];
	int ndefsta[MAXHYP];
	int nass[MAXHYP];
	int ndef[MAXHYP];
	double mindist[MAXHYP];
	double maxdist[MAXHYP];
	double azimgap[MAXHYP];
	/* varchar etype[MAXHYP][5]; */ 
struct { unsigned short len; unsigned char arr[6]; } etype[50];

	/* varchar agency[MAXHYP][AGLEN]; */ 
struct { unsigned short len; unsigned char arr[18]; } agency[50];

	double minax[MAXHYP];
	double majax[MAXHYP];
	double theta[MAXHYP];
	double stime[MAXHYP];
	double sdepth[MAXHYP];
	double sdobs[MAXHYP];

	/* Corresponding arrays of indicator variables */
	short msec_ind[MAXHYP],depth_ind[MAXHYP],nsta_ind[MAXHYP];
	short depfix_ind[MAXHYP],epifix_ind[MAXHYP],timfix_ind[MAXHYP];
	short ndefsta_ind[MAXHYP],nass_ind[MAXHYP],ndef_ind[MAXHYP];
	short mindist_ind[MAXHYP], maxdist_ind[MAXHYP];
	short azimgap_ind[MAXHYP],etype_ind[MAXHYP];
	short minax_ind[MAXHYP], majax_ind[MAXHYP],theta_ind[MAXHYP];
	short stime_ind[MAXHYP],sdepth_ind[MAXHYP],sdobs_ind[MAXHYP];


	/* EXEC SQL WHENEVER SQLERROR GOTO ORACLE_ERROR; */ 


	/* EXEC SQL SELECT hypid,
					to_number(to_char(day,'J')),
					to_number(to_char(day,'SSSSS')),
					msec,
					lat,
					lon,
					depth,
					depfix,
					epifix,
					timfix,
					nsta,
					ndefsta,
					nass,
					ndef,
					mindist,
					maxdist,
					azimgap,
					etype,
					author
			INTO	:hypid,
					:day,
					:sec,
					:msec:msec_ind,
					:lat,
					:lon,
					:depth:depth_ind,
					:depfix:depfix_ind,
					:epifix:epifix_ind,
					:timfix:timfix_ind,
					:nsta:nsta_ind,
					:ndefsta:ndefsta_ind,
					:nass:nass_ind,
					:ndef:ndef_ind,
					:mindist:mindist_ind,
					:maxdist:maxdist_ind,
					:azimgap:azimgap_ind,
					:etype:etype_ind,
					:agency
			FROM	hypocenter
			WHERE	(deprecated is NULL OR deprecated = 'M')
			AND		hypid = pref_hypid
			AND		isc_evid = :ep->evid
			ORDER BY hypid; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 20;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select hypid ,to_number(to_char(day,'J')) ,to_number(to_char\
(day,'SSSSS')) ,msec ,lat ,lon ,depth ,depfix ,epifix ,timfix ,nsta ,ndefsta ,\
nass ,ndef ,mindist ,maxdist ,azimgap ,etype ,author into :b0,:b1,:b2,:b3:b4,:\
b5,:b6,:b7:b8,:b9:b10,:b11:b12,:b13:b14,:b15:b16,:b17:b18,:b19:b20,:b21:b22,:b\
23:b24,:b25:b26,:b27:b28,:b29:b30,:b31  from hypocenter where (((deprecated is\
 null  or deprecated='M') and hypid=pref_hypid) and isc_evid=:b32) order by hy\
pid ";
 sqlstm.iters = (unsigned int  )50;
 sqlstm.offset = (unsigned int  )5;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (         void  *)hypid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqhsts[0] = (         int  )4;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqharc[0] = (unsigned int   *)0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)day;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqhsts[1] = (         int  )4;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqharc[1] = (unsigned int   *)0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)sec;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqhsts[2] = (         int  )4;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqharc[2] = (unsigned int   *)0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)msec;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqhsts[3] = (         int  )4;
 sqlstm.sqindv[3] = (         void  *)msec_ind;
 sqlstm.sqinds[3] = (         int  )2;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqharc[3] = (unsigned int   *)0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)lat;
 sqlstm.sqhstl[4] = (unsigned int  )8;
 sqlstm.sqhsts[4] = (         int  )8;
 sqlstm.sqindv[4] = (         void  *)0;
 sqlstm.sqinds[4] = (         int  )0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqharc[4] = (unsigned int   *)0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)lon;
 sqlstm.sqhstl[5] = (unsigned int  )8;
 sqlstm.sqhsts[5] = (         int  )8;
 sqlstm.sqindv[5] = (         void  *)0;
 sqlstm.sqinds[5] = (         int  )0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqharc[5] = (unsigned int   *)0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)depth;
 sqlstm.sqhstl[6] = (unsigned int  )8;
 sqlstm.sqhsts[6] = (         int  )8;
 sqlstm.sqindv[6] = (         void  *)depth_ind;
 sqlstm.sqinds[6] = (         int  )2;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqharc[6] = (unsigned int   *)0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqhstv[7] = (         void  *)depfix;
 sqlstm.sqhstl[7] = (unsigned int  )1;
 sqlstm.sqhsts[7] = (         int  )1;
 sqlstm.sqindv[7] = (         void  *)depfix_ind;
 sqlstm.sqinds[7] = (         int  )2;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqharc[7] = (unsigned int   *)0;
 sqlstm.sqadto[7] = (unsigned short )0;
 sqlstm.sqtdso[7] = (unsigned short )0;
 sqlstm.sqhstv[8] = (         void  *)epifix;
 sqlstm.sqhstl[8] = (unsigned int  )1;
 sqlstm.sqhsts[8] = (         int  )1;
 sqlstm.sqindv[8] = (         void  *)epifix_ind;
 sqlstm.sqinds[8] = (         int  )2;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqharc[8] = (unsigned int   *)0;
 sqlstm.sqadto[8] = (unsigned short )0;
 sqlstm.sqtdso[8] = (unsigned short )0;
 sqlstm.sqhstv[9] = (         void  *)timfix;
 sqlstm.sqhstl[9] = (unsigned int  )1;
 sqlstm.sqhsts[9] = (         int  )1;
 sqlstm.sqindv[9] = (         void  *)timfix_ind;
 sqlstm.sqinds[9] = (         int  )2;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqharc[9] = (unsigned int   *)0;
 sqlstm.sqadto[9] = (unsigned short )0;
 sqlstm.sqtdso[9] = (unsigned short )0;
 sqlstm.sqhstv[10] = (         void  *)nsta;
 sqlstm.sqhstl[10] = (unsigned int  )4;
 sqlstm.sqhsts[10] = (         int  )4;
 sqlstm.sqindv[10] = (         void  *)nsta_ind;
 sqlstm.sqinds[10] = (         int  )2;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqharc[10] = (unsigned int   *)0;
 sqlstm.sqadto[10] = (unsigned short )0;
 sqlstm.sqtdso[10] = (unsigned short )0;
 sqlstm.sqhstv[11] = (         void  *)ndefsta;
 sqlstm.sqhstl[11] = (unsigned int  )4;
 sqlstm.sqhsts[11] = (         int  )4;
 sqlstm.sqindv[11] = (         void  *)ndefsta_ind;
 sqlstm.sqinds[11] = (         int  )2;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqharc[11] = (unsigned int   *)0;
 sqlstm.sqadto[11] = (unsigned short )0;
 sqlstm.sqtdso[11] = (unsigned short )0;
 sqlstm.sqhstv[12] = (         void  *)nass;
 sqlstm.sqhstl[12] = (unsigned int  )4;
 sqlstm.sqhsts[12] = (         int  )4;
 sqlstm.sqindv[12] = (         void  *)nass_ind;
 sqlstm.sqinds[12] = (         int  )2;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqharc[12] = (unsigned int   *)0;
 sqlstm.sqadto[12] = (unsigned short )0;
 sqlstm.sqtdso[12] = (unsigned short )0;
 sqlstm.sqhstv[13] = (         void  *)ndef;
 sqlstm.sqhstl[13] = (unsigned int  )4;
 sqlstm.sqhsts[13] = (         int  )4;
 sqlstm.sqindv[13] = (         void  *)ndef_ind;
 sqlstm.sqinds[13] = (         int  )2;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqharc[13] = (unsigned int   *)0;
 sqlstm.sqadto[13] = (unsigned short )0;
 sqlstm.sqtdso[13] = (unsigned short )0;
 sqlstm.sqhstv[14] = (         void  *)mindist;
 sqlstm.sqhstl[14] = (unsigned int  )8;
 sqlstm.sqhsts[14] = (         int  )8;
 sqlstm.sqindv[14] = (         void  *)mindist_ind;
 sqlstm.sqinds[14] = (         int  )2;
 sqlstm.sqharm[14] = (unsigned int  )0;
 sqlstm.sqharc[14] = (unsigned int   *)0;
 sqlstm.sqadto[14] = (unsigned short )0;
 sqlstm.sqtdso[14] = (unsigned short )0;
 sqlstm.sqhstv[15] = (         void  *)maxdist;
 sqlstm.sqhstl[15] = (unsigned int  )8;
 sqlstm.sqhsts[15] = (         int  )8;
 sqlstm.sqindv[15] = (         void  *)maxdist_ind;
 sqlstm.sqinds[15] = (         int  )2;
 sqlstm.sqharm[15] = (unsigned int  )0;
 sqlstm.sqharc[15] = (unsigned int   *)0;
 sqlstm.sqadto[15] = (unsigned short )0;
 sqlstm.sqtdso[15] = (unsigned short )0;
 sqlstm.sqhstv[16] = (         void  *)azimgap;
 sqlstm.sqhstl[16] = (unsigned int  )8;
 sqlstm.sqhsts[16] = (         int  )8;
 sqlstm.sqindv[16] = (         void  *)azimgap_ind;
 sqlstm.sqinds[16] = (         int  )2;
 sqlstm.sqharm[16] = (unsigned int  )0;
 sqlstm.sqharc[16] = (unsigned int   *)0;
 sqlstm.sqadto[16] = (unsigned short )0;
 sqlstm.sqtdso[16] = (unsigned short )0;
 sqlstm.sqhstv[17] = (         void  *)etype;
 sqlstm.sqhstl[17] = (unsigned int  )7;
 sqlstm.sqhsts[17] = (         int  )8;
 sqlstm.sqindv[17] = (         void  *)etype_ind;
 sqlstm.sqinds[17] = (         int  )2;
 sqlstm.sqharm[17] = (unsigned int  )0;
 sqlstm.sqharc[17] = (unsigned int   *)0;
 sqlstm.sqadto[17] = (unsigned short )0;
 sqlstm.sqtdso[17] = (unsigned short )0;
 sqlstm.sqhstv[18] = (         void  *)agency;
 sqlstm.sqhstl[18] = (unsigned int  )19;
 sqlstm.sqhsts[18] = (         int  )20;
 sqlstm.sqindv[18] = (         void  *)0;
 sqlstm.sqinds[18] = (         int  )0;
 sqlstm.sqharm[18] = (unsigned int  )0;
 sqlstm.sqharc[18] = (unsigned int   *)0;
 sqlstm.sqadto[18] = (unsigned short )0;
 sqlstm.sqtdso[18] = (unsigned short )0;
 sqlstm.sqhstv[19] = (         void  *)&(ep->evid);
 sqlstm.sqhstl[19] = (unsigned int  )4;
 sqlstm.sqhsts[19] = (         int  )4;
 sqlstm.sqindv[19] = (         void  *)0;
 sqlstm.sqinds[19] = (         int  )0;
 sqlstm.sqharm[19] = (unsigned int  )0;
 sqlstm.sqadto[19] = (unsigned short )0;
 sqlstm.sqtdso[19] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto ORACLE_ERROR;
}



	numhyps = sqlca.sqlerrd[2];

	/* Check for something very odd - */
	/* get_event does same query to fill ep->numhyps. */
	if (numhyps != ep->numhyps){
		sprintf(errstr,"get_hyp unexpected numhyps %d",numhyps);
		return 1;
	}

	/* EXEC SQL SELECT e.hypid,
					sminax,
					smajax,
					strike,
					stime,
					sdepth,
					sdobs
			INTO	:err_hypid,
					:minax:minax_ind,
					:majax:majax_ind,
					:theta:theta_ind,
					:stime:stime_ind,
					:sdepth:sdepth_ind,
					:sdobs:sdobs_ind
			FROM	hypocenter h, hypoc_err e
			WHERE	isc_evid = :ep->evid
			AND		e.hypid = h.hypid
			AND		h.deprecated is null
			AND		h.hypid = h.pref_hypid
			ORDER BY h.hypid; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 20;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select e.hypid ,sminax ,smajax ,strike ,stime ,sdepth ,sdobs\
 into :b0,:b1:b2,:b3:b4,:b5:b6,:b7:b8,:b9:b10,:b11:b12  from hypocenter h ,hyp\
oc_err e where (((isc_evid=:b13 and e.hypid=h.hypid) and h.deprecated is null \
) and h.hypid=h.pref_hypid) order by h.hypid ";
 sqlstm.iters = (unsigned int  )50;
 sqlstm.offset = (unsigned int  )100;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (         void  *)err_hypid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqhsts[0] = (         int  )4;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqharc[0] = (unsigned int   *)0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)minax;
 sqlstm.sqhstl[1] = (unsigned int  )8;
 sqlstm.sqhsts[1] = (         int  )8;
 sqlstm.sqindv[1] = (         void  *)minax_ind;
 sqlstm.sqinds[1] = (         int  )2;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqharc[1] = (unsigned int   *)0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)majax;
 sqlstm.sqhstl[2] = (unsigned int  )8;
 sqlstm.sqhsts[2] = (         int  )8;
 sqlstm.sqindv[2] = (         void  *)majax_ind;
 sqlstm.sqinds[2] = (         int  )2;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqharc[2] = (unsigned int   *)0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)theta;
 sqlstm.sqhstl[3] = (unsigned int  )8;
 sqlstm.sqhsts[3] = (         int  )8;
 sqlstm.sqindv[3] = (         void  *)theta_ind;
 sqlstm.sqinds[3] = (         int  )2;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqharc[3] = (unsigned int   *)0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)stime;
 sqlstm.sqhstl[4] = (unsigned int  )8;
 sqlstm.sqhsts[4] = (         int  )8;
 sqlstm.sqindv[4] = (         void  *)stime_ind;
 sqlstm.sqinds[4] = (         int  )2;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqharc[4] = (unsigned int   *)0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)sdepth;
 sqlstm.sqhstl[5] = (unsigned int  )8;
 sqlstm.sqhsts[5] = (         int  )8;
 sqlstm.sqindv[5] = (         void  *)sdepth_ind;
 sqlstm.sqinds[5] = (         int  )2;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqharc[5] = (unsigned int   *)0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)sdobs;
 sqlstm.sqhstl[6] = (unsigned int  )8;
 sqlstm.sqhsts[6] = (         int  )8;
 sqlstm.sqindv[6] = (         void  *)sdobs_ind;
 sqlstm.sqinds[6] = (         int  )2;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqharc[6] = (unsigned int   *)0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqhstv[7] = (         void  *)&(ep->evid);
 sqlstm.sqhstl[7] = (unsigned int  )4;
 sqlstm.sqhsts[7] = (         int  )4;
 sqlstm.sqindv[7] = (         void  *)0;
 sqlstm.sqinds[7] = (         int  )0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqadto[7] = (unsigned short )0;
 sqlstm.sqtdso[7] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto ORACLE_ERROR;
}



	j=0;					/* Counter for hypoc_err query results. */
	for (i=0; i< numhyps; i++){
		h[i].hypid = hypid[i];

		/* Times stored as number of seconds since epoch */ 
		h[i].time  = (day[i]-ORACLE_EPOCH)*86400;
		h[i].time += sec[i];
		if (msec_ind[i]==0)
			h[i].time += (double)msec[i]/1000;

		h[i].lat = lat[i];
		h[i].lon = lon[i];
		calc_dircos(lat[i],lon[i],h[i].dircos);

		if (depth_ind[i]==0)
			h[i].depth = depth[i];
		else
			h[i].depth = NULLVAL;

		if (depfix_ind[i]==0)
			h[i].depfix = 1;
		else
			h[i].depfix = 0;
		if (epifix[i]==0)
			h[i].epifix = 1;
		else
			h[i].epifix = 0;
		if (timfix[i]==0)
			h[i].timfix = 1;
		else
			h[i].timfix = 0;

		if (nsta_ind[i]==0)
			h[i].nsta = nsta[i];
		else
			h[i].nsta = NULLVAL;
		if (ndefsta_ind[i]==0)
			h[i].ndefsta = ndefsta[i];
		else
			h[i].ndefsta = NULLVAL;
		if (nass_ind[i]==0)
			h[i].nass = nass[i];
		else
			h[i].nass = NULLVAL;
		if (ndef_ind[i]==0)
			h[i].ndef = ndef[i];
		else
			h[i].ndef = NULLVAL;

		if (mindist_ind[i]==0)
			h[i].mindist = mindist[i];
		else
			h[i].mindist = NULLVAL;
		if (maxdist_ind[i]==0)
			h[i].maxdist = maxdist[i];
		else
			h[i].maxdist = NULLVAL;
		if (azimgap_ind[i]==0)
			h[i].azimgap = azimgap[i];
		else
			h[i].azimgap = NULLVAL;

		if (etype_ind[i]==0){
			strncpy(h[i].etype,etype[i].arr,etype[i].len);
			h[i].etype[etype[i].len] = '\0';
		}
		else
			h[i].etype[0] = '\0';

		strncpy(h[i].agency,agency[i].arr,agency[i].len);
		h[i].agency[agency[i].len] = '\0';

		/* May or may not be hypoc_err row for this hypid */
		if (err_hypid[j] == hypid[i]){

			if (minax_ind[j]==0)
				h[i].minax = minax[j];
			else
				h[i].minax = NULLVAL;
			if (majax_ind[j]==0)
				h[i].majax = majax[j];
			else
				h[i].majax = NULLVAL;
			if (theta_ind[j]==0)
				h[i].theta = theta[j];
			else
				h[i].theta = NULLVAL;
			if (stime_ind[j]==0)
				h[i].stime = stime[j];
			else
				h[i].stime = NULLVAL;
			if (sdepth_ind[j]==0)
				h[i].sdepth = sdepth[j];
			else
				h[i].sdepth = NULLVAL;
			if (sdobs_ind[j]==0)
				h[i].sdobs = sdobs[j];
			else
				h[i].sdobs = NULLVAL;

			j++;
		}
		else {
			h[i].minax = NULLVAL;
			h[i].majax = NULLVAL;
			h[i].theta = NULLVAL;
			h[i].stime = NULLVAL;
			h[i].sdepth = NULLVAL;
			h[i].sdobs = NULLVAL;
		}
	}
	return 0;

ORACLE_ERROR:

	sql_error("get_hyp:");
	return 1;
}

