
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned long magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn; 
  unsigned short tvnvsnl; 
  unsigned char *tvnnm;
  unsigned short tvnnml; 
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn; 
  unsigned short adtmode; 
  unsigned short adtnum;  
  sqltvn adttvn[1];       
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,1,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
  unsigned int tdsvsn; 
  unsigned short tdsnum; 
  unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[11];
};
static struct sqlcxp sqlfpn =
{
    10,
    "get_pha.pc"
};


static unsigned long sqlctx = 75491;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   unused;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
            void  **sqphsv;
   unsigned int   *sqphsl;
            int   *sqphss;
            void  **sqpind;
            int   *sqpins;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
            void  *sqhstv[21];
   unsigned int   sqhstl[21];
            int   sqhsts[21];
            void  *sqindv[21];
            int   sqinds[21];
   unsigned int   sqharm[21];
   unsigned int   *sqharc[21];
   unsigned short  sqadto[21];
   unsigned short  sqtdso[21];
} sqlstm = {10,21};

/* SQLLIB Prototypes */
extern sqlcxt (/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned long *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned long *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern void sqliem(/*_ char *, int * _*/);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* CUD (Compilation Unit Data) Array */
static short sqlcud0[] =
{10,4130,0,0,0,
5,0,0,1,570,0,4,82,0,0,21,1,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,
0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,4,0,0,2,4,0,0,2,9,0,0,2,9,0,0,2,9,0,0,2,
9,0,0,2,9,0,0,2,4,0,0,2,4,0,0,2,4,0,0,1,3,0,0,
104,0,0,2,241,0,4,141,0,0,3,1,0,1,0,2,3,0,0,2,3,0,0,1,3,0,0,
131,0,0,3,271,0,4,156,0,0,7,1,0,1,0,2,3,0,0,2,4,0,0,2,4,0,0,2,4,0,0,2,9,0,0,2,
9,0,0,1,3,0,0,
};


#include "location.h"

/*#DOC  Title:																*/
/*#DOC    get_pha															*/
/*#DOC  Desc:																*/
/*#DOC    Reads database and fills phase structures.						*/
/*#DOC  Input Arguments:													*/
/*#DOC    ep  - pointer to structure containing an event.					*/
/*#DOC    p[] - array of phase structures.									*/
/*#DOC  Return:																*/
/*#DOC    0/1 for success/failure.											*/
/*#DOC  Uses:																*/
/*#DOC	  sql_error() from oracle_funcs.									*/
/*#DOC	  This code must be precompiled using the ORACLE proc.				*/

/*	Extract phase, amplitude, and reporter association data from ORACLE.	*/

/*	Need three seperate queries as phases may or may not be associated		*/
/*	by their reporter and may or may not have one or more amplitudes.		*/
/*	By ordering all 3 queries by phid allow the transferral of values		*/
/*	from the resulting local arrays into the structures in one loop with	*/
/*	3 indexes.																*/
/*	The hypid that a phase is associated with by its reporter is only		*/
/*	used when ranking the hypocentres for this event.						*/
/*	Adjust amplitudes for p-to-p amptype here.								*/
/*	Store station information with every phase. 							*/

/* EXEC SQL INCLUDE SQLCA;
 */ 
/*
 * $Header: sqlca.h,v 1.3 1994/12/12 19:27:27 jbasu Exp $ sqlca.h 
 */

/* Copyright (c) 1985,1986, 1998 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    lvbcheng   10/28/98 -  Undo long to int
    lvbcheng   08/03/98 -  Change sqlca long attrs to ints
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ long    sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */


int get_pha(struct event_rec *ep, struct pha_rec p[])
{
	int numphas;
	int i,j,k,m;

	/* Local arrays to store selected data. */
	int phid[MAXPHA];
	int rdid[MAXPHA];
	int pref_rd[MAXPHA];
	int ass_phid[MAXPHA];
	int amp_phid[MAXPHA];
	int day[MAXPHA];
	int sec[MAXPHA];
	int msec[MAXPHA];
	/* varchar init[MAXPHA][1]; */ 
struct { unsigned short len; unsigned char arr[2]; } init[5000];

	/* varchar rep_phase[MAXPHA][PHALEN]; */ 
struct { unsigned short len; unsigned char arr[10]; } rep_phase[5000];

	/* varchar net[MAXPHA][NETLEN]; */ 
struct { unsigned short len; unsigned char arr[10]; } net[5000];

	/* varchar sta[MAXPHA][STALEN]; */ 
struct { unsigned short len; unsigned char arr[10]; } sta[5000];

	float slow[MAXPHA];
	float azim[MAXPHA];
	/* varchar chan[MAXPHA][3]; */ 
struct { unsigned short len; unsigned char arr[6]; } chan[5000];

	/* varchar sp_fm[MAXPHA][1]; */ 
struct { unsigned short len; unsigned char arr[2]; } sp_fm[5000];

	/* varchar lp_fm[MAXPHA][1]; */ 
struct { unsigned short len; unsigned char arr[2]; } lp_fm[5000];

	/* varchar emergent[MAXPHA][1]; */ 
struct { unsigned short len; unsigned char arr[2]; } emergent[5000];

	/* varchar impulsive[MAXPHA][1]; */ 
struct { unsigned short len; unsigned char arr[2]; } impulsive[5000];

	float sta_lat[MAXPHA];
	float sta_lon[MAXPHA];
	float sta_elev[MAXPHA];
	int hypid[MAXPHA];
	double amp[MAXPHA];
	double per[MAXPHA];
	double logat[MAXPHA];
	/* varchar amptype[MAXPHA][9]; */ 
struct { unsigned short len; unsigned char arr[10]; } amptype[5000];

	/* varchar ampchan[MAXPHA][3]; */ 
struct { unsigned short len; unsigned char arr[6]; } ampchan[5000];


	/* Corresponding arrays of indicator variables */
	short init_ind[MAXPHA],phase_ind[MAXPHA],day_ind[MAXPHA],sec_ind[MAXPHA];
	short msec_ind[MAXPHA],net_ind[MAXPHA],slow_ind[MAXPHA],azim_ind[MAXPHA];
	short chan_ind[MAXPHA],sp_fm_ind[MAXPHA],lp_fm_ind[MAXPHA];
	short emergent_ind[MAXPHA],impulsive_ind[MAXPHA];
	short elev_ind[MAXPHA],amp_ind[MAXPHA],per_ind[MAXPHA];
	short logat_ind[MAXPHA],ampchan_ind[MAXPHA],amptype_ind[MAXPHA];

	/* Check array sizes. */
	if (ep->numphas > MAXPHA){
		sprintf(errstr,"get_pha: too many phases %d",ep->numphas);
		return 1;
	}

	/* EXEC SQL WHENEVER SQLERROR GOTO ORACLE_ERROR; */ 


	/* Select phases ISC associated to this event (ie to the prime hyp) */
	/* EXEC SQL SELECT p.phid,
					rdid,
					pref_rd,
					to_number(to_char(day,'J')),
					to_number(to_char(day,'SSSSS')),
					msec,
					init,
					p.phase,
					p.net,
					p.sta,
					slow,
					azim,
					chan,
					sp_fm,
					lp_fm,
					emergent,
					impulsive,
					lat,
					lon,
					elev
			INTO	:phid,
					:rdid,
					:pref_rd,
					:day:day_ind,
					:sec:sec_ind,
					:msec:msec_ind,
					:init:init_ind,
					:rep_phase:phase_ind,
					:net:net_ind,
					:sta,
					:slow:slow_ind,
					:azim:azim_ind,
					:chan:chan_ind,
					:sp_fm:sp_fm_ind,
					:lp_fm:lp_fm_ind,
					:emergent:emergent_ind,
					:impulsive:impulsive_ind,
					:sta_lat,
					:sta_lon,
					:sta_elev:elev_ind
			FROM	phase p, association a, site s
			WHERE	a.hypid = :ep->prime
			AND		a.author = 'ISC'
			AND		p.phid = a.phid
			AND		p.deprecated is NULL
			AND		s.sta = p.sta
			AND		(s.net = p.net OR (s.net is NULL AND p.net is NULL))
			ORDER BY a.sta,a.phid; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 21;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select p.phid ,rdid ,pref_rd ,to_number(to_char(day,'J')) ,t\
o_number(to_char(day,'SSSSS')) ,msec ,init ,p.phase ,p.net ,p.sta ,slow ,azim \
,chan ,sp_fm ,lp_fm ,emergent ,impulsive ,lat ,lon ,elev into :b0,:b1,:b2,:b3:\
b4,:b5:b6,:b7:b8,:b9:b10,:b11:b12,:b13:b14,:b15,:b16:b17,:b18:b19,:b20:b21,:b2\
2:b23,:b24:b25,:b26:b27,:b28:b29,:b30,:b31,:b32:b33  from phase p ,association\
 a ,site s where (((((a.hypid=:b34 and a.author='ISC') and p.phid=a.phid) and \
p.deprecated is null ) and s.sta=p.sta) and (s.net=p.net or (s.net is null  an\
d p.net is null ))) order by a.sta,a.phid ";
 sqlstm.iters = (unsigned int  )5000;
 sqlstm.offset = (unsigned int  )5;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (         void  *)phid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqhsts[0] = (         int  )4;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqharc[0] = (unsigned int   *)0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)rdid;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqhsts[1] = (         int  )4;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqharc[1] = (unsigned int   *)0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)pref_rd;
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqhsts[2] = (         int  )4;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqharc[2] = (unsigned int   *)0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)day;
 sqlstm.sqhstl[3] = (unsigned int  )4;
 sqlstm.sqhsts[3] = (         int  )4;
 sqlstm.sqindv[3] = (         void  *)day_ind;
 sqlstm.sqinds[3] = (         int  )2;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqharc[3] = (unsigned int   *)0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)sec;
 sqlstm.sqhstl[4] = (unsigned int  )4;
 sqlstm.sqhsts[4] = (         int  )4;
 sqlstm.sqindv[4] = (         void  *)sec_ind;
 sqlstm.sqinds[4] = (         int  )2;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqharc[4] = (unsigned int   *)0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)msec;
 sqlstm.sqhstl[5] = (unsigned int  )4;
 sqlstm.sqhsts[5] = (         int  )4;
 sqlstm.sqindv[5] = (         void  *)msec_ind;
 sqlstm.sqinds[5] = (         int  )2;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqharc[5] = (unsigned int   *)0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)init;
 sqlstm.sqhstl[6] = (unsigned int  )3;
 sqlstm.sqhsts[6] = (         int  )4;
 sqlstm.sqindv[6] = (         void  *)init_ind;
 sqlstm.sqinds[6] = (         int  )2;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqharc[6] = (unsigned int   *)0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqhstv[7] = (         void  *)rep_phase;
 sqlstm.sqhstl[7] = (unsigned int  )11;
 sqlstm.sqhsts[7] = (         int  )12;
 sqlstm.sqindv[7] = (         void  *)phase_ind;
 sqlstm.sqinds[7] = (         int  )2;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqharc[7] = (unsigned int   *)0;
 sqlstm.sqadto[7] = (unsigned short )0;
 sqlstm.sqtdso[7] = (unsigned short )0;
 sqlstm.sqhstv[8] = (         void  *)net;
 sqlstm.sqhstl[8] = (unsigned int  )9;
 sqlstm.sqhsts[8] = (         int  )12;
 sqlstm.sqindv[8] = (         void  *)net_ind;
 sqlstm.sqinds[8] = (         int  )2;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqharc[8] = (unsigned int   *)0;
 sqlstm.sqadto[8] = (unsigned short )0;
 sqlstm.sqtdso[8] = (unsigned short )0;
 sqlstm.sqhstv[9] = (         void  *)sta;
 sqlstm.sqhstl[9] = (unsigned int  )9;
 sqlstm.sqhsts[9] = (         int  )12;
 sqlstm.sqindv[9] = (         void  *)0;
 sqlstm.sqinds[9] = (         int  )0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqharc[9] = (unsigned int   *)0;
 sqlstm.sqadto[9] = (unsigned short )0;
 sqlstm.sqtdso[9] = (unsigned short )0;
 sqlstm.sqhstv[10] = (         void  *)slow;
 sqlstm.sqhstl[10] = (unsigned int  )4;
 sqlstm.sqhsts[10] = (         int  )4;
 sqlstm.sqindv[10] = (         void  *)slow_ind;
 sqlstm.sqinds[10] = (         int  )2;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqharc[10] = (unsigned int   *)0;
 sqlstm.sqadto[10] = (unsigned short )0;
 sqlstm.sqtdso[10] = (unsigned short )0;
 sqlstm.sqhstv[11] = (         void  *)azim;
 sqlstm.sqhstl[11] = (unsigned int  )4;
 sqlstm.sqhsts[11] = (         int  )4;
 sqlstm.sqindv[11] = (         void  *)azim_ind;
 sqlstm.sqinds[11] = (         int  )2;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqharc[11] = (unsigned int   *)0;
 sqlstm.sqadto[11] = (unsigned short )0;
 sqlstm.sqtdso[11] = (unsigned short )0;
 sqlstm.sqhstv[12] = (         void  *)chan;
 sqlstm.sqhstl[12] = (unsigned int  )5;
 sqlstm.sqhsts[12] = (         int  )8;
 sqlstm.sqindv[12] = (         void  *)chan_ind;
 sqlstm.sqinds[12] = (         int  )2;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqharc[12] = (unsigned int   *)0;
 sqlstm.sqadto[12] = (unsigned short )0;
 sqlstm.sqtdso[12] = (unsigned short )0;
 sqlstm.sqhstv[13] = (         void  *)sp_fm;
 sqlstm.sqhstl[13] = (unsigned int  )3;
 sqlstm.sqhsts[13] = (         int  )4;
 sqlstm.sqindv[13] = (         void  *)sp_fm_ind;
 sqlstm.sqinds[13] = (         int  )2;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqharc[13] = (unsigned int   *)0;
 sqlstm.sqadto[13] = (unsigned short )0;
 sqlstm.sqtdso[13] = (unsigned short )0;
 sqlstm.sqhstv[14] = (         void  *)lp_fm;
 sqlstm.sqhstl[14] = (unsigned int  )3;
 sqlstm.sqhsts[14] = (         int  )4;
 sqlstm.sqindv[14] = (         void  *)lp_fm_ind;
 sqlstm.sqinds[14] = (         int  )2;
 sqlstm.sqharm[14] = (unsigned int  )0;
 sqlstm.sqharc[14] = (unsigned int   *)0;
 sqlstm.sqadto[14] = (unsigned short )0;
 sqlstm.sqtdso[14] = (unsigned short )0;
 sqlstm.sqhstv[15] = (         void  *)emergent;
 sqlstm.sqhstl[15] = (unsigned int  )3;
 sqlstm.sqhsts[15] = (         int  )4;
 sqlstm.sqindv[15] = (         void  *)emergent_ind;
 sqlstm.sqinds[15] = (         int  )2;
 sqlstm.sqharm[15] = (unsigned int  )0;
 sqlstm.sqharc[15] = (unsigned int   *)0;
 sqlstm.sqadto[15] = (unsigned short )0;
 sqlstm.sqtdso[15] = (unsigned short )0;
 sqlstm.sqhstv[16] = (         void  *)impulsive;
 sqlstm.sqhstl[16] = (unsigned int  )3;
 sqlstm.sqhsts[16] = (         int  )4;
 sqlstm.sqindv[16] = (         void  *)impulsive_ind;
 sqlstm.sqinds[16] = (         int  )2;
 sqlstm.sqharm[16] = (unsigned int  )0;
 sqlstm.sqharc[16] = (unsigned int   *)0;
 sqlstm.sqadto[16] = (unsigned short )0;
 sqlstm.sqtdso[16] = (unsigned short )0;
 sqlstm.sqhstv[17] = (         void  *)sta_lat;
 sqlstm.sqhstl[17] = (unsigned int  )4;
 sqlstm.sqhsts[17] = (         int  )4;
 sqlstm.sqindv[17] = (         void  *)0;
 sqlstm.sqinds[17] = (         int  )0;
 sqlstm.sqharm[17] = (unsigned int  )0;
 sqlstm.sqharc[17] = (unsigned int   *)0;
 sqlstm.sqadto[17] = (unsigned short )0;
 sqlstm.sqtdso[17] = (unsigned short )0;
 sqlstm.sqhstv[18] = (         void  *)sta_lon;
 sqlstm.sqhstl[18] = (unsigned int  )4;
 sqlstm.sqhsts[18] = (         int  )4;
 sqlstm.sqindv[18] = (         void  *)0;
 sqlstm.sqinds[18] = (         int  )0;
 sqlstm.sqharm[18] = (unsigned int  )0;
 sqlstm.sqharc[18] = (unsigned int   *)0;
 sqlstm.sqadto[18] = (unsigned short )0;
 sqlstm.sqtdso[18] = (unsigned short )0;
 sqlstm.sqhstv[19] = (         void  *)sta_elev;
 sqlstm.sqhstl[19] = (unsigned int  )4;
 sqlstm.sqhsts[19] = (         int  )4;
 sqlstm.sqindv[19] = (         void  *)elev_ind;
 sqlstm.sqinds[19] = (         int  )2;
 sqlstm.sqharm[19] = (unsigned int  )0;
 sqlstm.sqharc[19] = (unsigned int   *)0;
 sqlstm.sqadto[19] = (unsigned short )0;
 sqlstm.sqtdso[19] = (unsigned short )0;
 sqlstm.sqhstv[20] = (         void  *)&(ep->prime);
 sqlstm.sqhstl[20] = (unsigned int  )4;
 sqlstm.sqhsts[20] = (         int  )4;
 sqlstm.sqindv[20] = (         void  *)0;
 sqlstm.sqinds[20] = (         int  )0;
 sqlstm.sqharm[20] = (unsigned int  )0;
 sqlstm.sqadto[20] = (unsigned short )0;
 sqlstm.sqtdso[20] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto ORACLE_ERROR;
}



	numphas = sqlca.sqlerrd[2];

	/* Check for something very odd - */
	/* get_event does same query to fill ep->numphas. */
	if (numphas != ep->numphas){
		sprintf(errstr,"get_pha:%d: unexpected numphas %d",ep->evid,numphas);
		return 1;
	}

	/* Select reported associations for any of the phases selected above. */
	/* EXEC SQL SELECT a2.hypid,
					p.phid
			INTO	:hypid,
					:ass_phid
			FROM	phase p, association a1, association a2
			WHERE	a1.hypid = :ep->prime
			AND		a1.author = 'ISC'
			AND		p.phid = a1.phid
			AND		p.deprecated is NULL
			AND		a2.phid = p.phid
			AND		a2.author != 'ISC'
			ORDER BY a1.sta,a1.phid; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 21;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select a2.hypid ,p.phid into :b0,:b1  from phase p ,associat\
ion a1 ,association a2 where (((((a1.hypid=:b2 and a1.author='ISC') and p.phid\
=a1.phid) and p.deprecated is null ) and a2.phid=p.phid) and a2.author<>'ISC')\
 order by a1.sta,a1.phid ";
 sqlstm.iters = (unsigned int  )5000;
 sqlstm.offset = (unsigned int  )104;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (         void  *)hypid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqhsts[0] = (         int  )4;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqharc[0] = (unsigned int   *)0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)ass_phid;
 sqlstm.sqhstl[1] = (unsigned int  )4;
 sqlstm.sqhsts[1] = (         int  )4;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqharc[1] = (unsigned int   *)0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&(ep->prime);
 sqlstm.sqhstl[2] = (unsigned int  )4;
 sqlstm.sqhsts[2] = (         int  )4;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto ORACLE_ERROR;
}



	/* Select amplitudes for any selected phase. */
	/* The resulting amp_phid array may have the same phids repeatedly. */
	/* EXEC SQL SELECT p.phid,
					amp,
					per,
					logat,
					amptype,
					amp.chan
			INTO	:amp_phid,
					:amp:amp_ind,
					:per:per_ind,
					:logat:logat_ind,
					:amptype:amptype_ind,
					:ampchan:ampchan_ind
			FROM	phase p, amplitude amp, association a
			WHERE	a.hypid = :ep->prime
			AND		a.author = 'ISC'
			AND		p.phid = a.phid
			AND		p.deprecated is NULL
			AND		amp.phid = p.phid
			ORDER BY a.sta,a.phid; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 21;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select p.phid ,amp ,per ,logat ,amptype ,amp.chan into :b0,:\
b1:b2,:b3:b4,:b5:b6,:b7:b8,:b9:b10  from phase p ,amplitude amp ,association a\
 where ((((a.hypid=:b11 and a.author='ISC') and p.phid=a.phid) and p.deprecate\
d is null ) and amp.phid=p.phid) order by a.sta,a.phid ";
 sqlstm.iters = (unsigned int  )5000;
 sqlstm.offset = (unsigned int  )131;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)0;
 sqlstm.sqhstv[0] = (         void  *)amp_phid;
 sqlstm.sqhstl[0] = (unsigned int  )4;
 sqlstm.sqhsts[0] = (         int  )4;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqharc[0] = (unsigned int   *)0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)amp;
 sqlstm.sqhstl[1] = (unsigned int  )8;
 sqlstm.sqhsts[1] = (         int  )8;
 sqlstm.sqindv[1] = (         void  *)amp_ind;
 sqlstm.sqinds[1] = (         int  )2;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqharc[1] = (unsigned int   *)0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)per;
 sqlstm.sqhstl[2] = (unsigned int  )8;
 sqlstm.sqhsts[2] = (         int  )8;
 sqlstm.sqindv[2] = (         void  *)per_ind;
 sqlstm.sqinds[2] = (         int  )2;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqharc[2] = (unsigned int   *)0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)logat;
 sqlstm.sqhstl[3] = (unsigned int  )8;
 sqlstm.sqhsts[3] = (         int  )8;
 sqlstm.sqindv[3] = (         void  *)logat_ind;
 sqlstm.sqinds[3] = (         int  )2;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqharc[3] = (unsigned int   *)0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)amptype;
 sqlstm.sqhstl[4] = (unsigned int  )11;
 sqlstm.sqhsts[4] = (         int  )12;
 sqlstm.sqindv[4] = (         void  *)amptype_ind;
 sqlstm.sqinds[4] = (         int  )2;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqharc[4] = (unsigned int   *)0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)ampchan;
 sqlstm.sqhstl[5] = (unsigned int  )5;
 sqlstm.sqhsts[5] = (         int  )8;
 sqlstm.sqindv[5] = (         void  *)ampchan_ind;
 sqlstm.sqinds[5] = (         int  )2;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqharc[5] = (unsigned int   *)0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)&(ep->prime);
 sqlstm.sqhstl[6] = (unsigned int  )4;
 sqlstm.sqhsts[6] = (         int  )4;
 sqlstm.sqindv[6] = (         void  *)0;
 sqlstm.sqinds[6] = (         int  )0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto ORACLE_ERROR;
}



	/* Transfer values from the local arrays into phase structures.		*/
	/* Each phase associated by the ISC gets one structure, which may	*/
	/* or may not contain reported association hypid and/or an array	*/
	/* of amplitude structures.											*/
	j=0;				/* Index for phases with reported associations. */
	k=0;				/* Index for phases with amplitudes. */
	for (i=0; i<numphas; i++){
		p[i].phid = phid[i];
		p[i].rdid = rdid[i];
		p[i].pref_rd = pref_rd[i];

		/* Times stored as number of seconds since 01-01-2000 */ 
		if (day_ind[i]==0){
			p[i].time = (day[i]-ORACLE_EPOCH)*86400;
			p[i].time += sec[i];
			if (msec_ind[i]==0)
				p[i].time += (double)msec[i]/1000;
		}
		else
			p[i].time = NULLVAL;

		if (init_ind[i]==0)
			p[i].init = 1;
		else
			p[i].init = 0;

		if (phase_ind[i]==0){
			strncpy(p[i].rep_phase,rep_phase[i].arr,rep_phase[i].len);
			p[i].rep_phase[rep_phase[i].len] = '\0';
		}
		else
			p[i].rep_phase[0] = '\0';

		if (net_ind[i]==0){
			strncpy(p[i].net,net[i].arr,net[i].len);
			p[i].net[net[i].len] = '\0';
		}
		else
			p[i].net[0] = '\0';

		strncpy(p[i].sta,sta[i].arr,sta[i].len);
		p[i].sta[sta[i].len] = '\0';

		if (slow_ind[i]==0)
			p[i].slow = slow[i];
		else
			p[i].slow = NULLVAL;
		if (azim_ind[i]==0)
			p[i].azim = azim[i];
		else
			p[i].azim = NULLVAL;

		if (chan_ind[i]==0 && chan[i].arr[2] != '?')
			p[i].comp = chan[i].arr[2];
		else
			p[i].comp = 0;

		if (sp_fm_ind[i]==0)
			p[i].sp_fm = sp_fm[i].arr[0];
		else
			p[i].sp_fm = ' ';

		if (emergent_ind[i]==0 && impulsive_ind[i]==0)
			p[i].detchar = 'q';
		else if (impulsive_ind[i]==0)
			p[i].detchar = 'i';
		else if (emergent_ind[i]==0)
			p[i].detchar = 'e';
		else
			p[i].detchar = ' ';

		/* Station info stored with every phase. */
		p[i].sta_lat = sta_lat[i];
		p[i].sta_lon = sta_lon[i];
		if (elev_ind[i]==0)
			p[i].sta_elev = sta_elev[i];
		if (p[i].init)
			calc_dircos(sta_lat[i],sta_lon[i],p[i].dircos);
		else
			for (m=1; m<=6; m++)
				p[i].dircos[m] = p[i-1].dircos[m];

		/* p.hypid only meaningful if reporter associated that phase. */
		if (ass_phid[j] == phid[i]){
			p[i].hypid = hypid[j];
			j++;
		}
		else
			p[i].hypid = hypid[j];

		/* Phase has 0 or more amplitudes, store number as p.numamps.	*/
		m=0; 					/* Index for amplitude structure array.	*/
		while (amp_phid[k] == phid[i]){
			if (amp_ind[k]==0)
				p[i].a[m].amp = amp[k];
			else
				p[i].a[m].amp = NULLVAL;
			if (per_ind[k]==0)
				p[i].a[m].per = per[k];
			else
				p[i].a[m].per = NULLVAL;
			if (logat_ind[k]==0)
				p[i].a[m].logat = logat[k];
			else
				p[i].a[m].logat = NULLVAL;
			if (amptype_ind[k]==0)
				if (strncmp("p-to-p",amptype[k].arr,amptype[k].len)==0)
					p[i].a[m].amp /= 2;

			/* If no component given for amplitude then use one from phase. */
			if (ampchan_ind[k]==0 && ampchan[k].arr[2] != '?')
				p[i].a[m].comp = ampchan[k].arr[2];
			else if (p[i].comp)
				p[i].a[m].comp = p[i].comp;
			else
				p[i].a[m].comp = 0;
			m++;
			k++;
		}
		p[i].numamps = m;
	}
	return 0;

ORACLE_ERROR:

	sql_error("get_pha:");
	return 1;
}

