#include "location.h"

/*#DOC  Title:																*/
/*#DOC    no_weight															*/
/*#DOC  Desc:																*/
/*#DOC    Fills 'alpha' in solution structure and 'weight' for each phase.	*/
/*#DOC  Input Arguments:													*/
/*#DOC    sp - pointer to structure containing current solution.			*/
/*#DOC    p[]  - array of pointers to structures containing phases.			*/
/*#DOC  Return:																*/
/*#DOC    0/1 for success/failure.											*/


int no_weight (struct sol_rec *sp, struct pha_rec p[])
{
	extern int    min_phases;			/* From config file */
	extern double max_resid;			/* From config file */

	int i,ndef;
	double total_weight;

	sp->alpha=0;
	total_weight=0;
	ndef=0;
	for (i=0; i<sp->numphas; i++){
		if (p[i].weight_factor > 0 && fabs(p[i].resid) < max_resid){
			p[i].weight   = p[i].weight_factor;
			total_weight += p[i].weight;
			sp->alpha    += p[i].resid*p[i].weight;
			ndef++;
		}
		else{
			p[i].weight = 0;
		}
	}
	if (ndef < min_phases){
		fprintf(logfp,"TOO FEW PHASES no_weight: ndef=%d\n",ndef);
		strcpy(errstr,"");
		return 1;
	}
	sp->alpha /= total_weight;

	if (sp->iteration == 0)
		sp->prev_alpha = sp->alpha;

	return 0;
}
