#include "location.h"

/*#DOC  Title:																*/
/*#DOC    put_data															*/
/*#DOC  Desc:																*/
/*#DOC    Writes solution to database.										*/
/*#DOC  Input Arguments:													*/
/*#DOC    ep  - pointer to structure containing event information.			*/
/*#DOC    sp  - pointer to structure containing current solution.			*/
/*#DOC    p[] - array of pointers to structures containing phases.			*/
/*#DOC  Return:																*/
/*#DOC    0/1 for success/failure.											*/
/*#DOC  Uses:																*/
/*#DOC	  put_hyp(), put_event(), and put_pha().							*/

/* At the moment just adds a hypocentre.  Do not want more than one ISC		*/
/* hypocentre for an event so will need to deprecate or update any 			*/
/* existing ISC hypocentre, which will have its hypid stored in e.isc_hypid.*/

int put_data(struct event_rec *ep, struct sol_rec *sp, struct pha_rec p[])
{

	/* Write new hypocentre to database - one day will cope with old ISC. */
	if (put_hyp(ep, sp))
		return 1;

	/* Update prime hypocentre for ISC event. */
	if (put_event(ep))
		return 1;

	/* Update phase and association rows. */
	if (put_pha(sp, p))
		return 1;

	return 0;
}
