#include "location.h"

/*#DOC  Title:																*/
/*#DOC    read_pP_P															*/
/*#DOC  Desc:																*/
/*#DOC    Calls function to look up pP - P times.							*/
/*#DOC  Input Arguments:													*/
/*#DOC    depth - depth of current solution.								*/
/*#DOC    pp  - pointer to a phase structure.								*/
/*#DOC  Return:																*/
/*#DOC    0/1 for success/failure.											*/
/*#DOC  Calls:																*/
/*#DOC	  jb_pP_P() from jb_pP_P.c											*/

/* Calculates pP-P time and corresponding dtdh for a single phase.	*/
/* Here simply as a wrapper for the subroutine that does the work,	*/
/* which will depend on the tables/model being used.				*/

int read_pP_P (double depth, struct pha_rec *pp)
{

	if( jb_pP_P( pp->delta, depth, &pp->pP_P_time, &pp->pP_dtdh) )
		return 1;

	return 0;
}
