#include "location.h"
#include "jb_model.h"

/*#DOC    read_ttime														*/
/*#DOC  Desc:																*/
/*#DOC    Wrapper for whatever travel time function is in use.				*/
/*#DOC  Input Arguments:													*/
/*#DOC    sp - pointer to structure containing current solution.			*/
/*#DOC    pp - pointer to a phase structure.								*/
/*#DOC  Return:																*/
/*#DOC    0/1/2/3 for success/failure/warning/wrong phase.					*/
/*#DOC  Calls:																*/
/*#DOC	  read_jb() from read_jb.c.											*/
/*#DOC	  correct_ttime() from correct_ttime.c.								*/
/*#DOC	  add_to_error() from utils.c.										*/

/* This function will need to be rewritten to use a different earth model,	*/
/* even if just to change the called function's name.						*/

/* Set external max_depth to greatest depth that occurs in tables (in km).	*/
/* This is required by calc_resid to weed out solutions that travel times	*/
/* can't be calculated for.													*/
double max_depth = EARTH_RADIUS*MAX_DEPTH;

int read_ttime (struct sol_rec *sp, struct pha_rec *pp)
{
	int status;
	int read_jb (double depth, struct pha_rec *pp);

	status = read_jb (sp->depth,pp);
	if (status){
		add_to_error("read_jb:");
		return status;
	}

	if (correct_ttime (sp,pp)){
		return 1;
	}
	return 0;
}
